### *** This interface provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.information.metadata

# Interface RelationalKeyInterface

All Superinterfaces:
  `ColumnContainerInterface`, `MetadataInterface`, `PublicObjectInterface`, `Remote`

@SASScope("ALL") @BinaryCompatibilityOnly public interface RelationalKeyInterface extends ColumnContainerInterface
Represents Unique Key associated with the Relational Table.

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `IndexInterface`
  `getAssociatedIndex()`
  Get the associated index with a Unique/Primary Key.
  `List<ForeignKeyInterface>`
  `getForeignKeys()`
  Get associated foreign keys of the Relational Key.
  `RelationalKeyInterface.KeyType`
  `getKeyType()`
  Get a key type of the relational key which could be either Primary or Unique.
  `void`
  `setAssociatedIndex(IndexInterface index)`
  Set the associated index with a Unique/Primary Key.
  `void`
  `setKeyType(RelationalKeyInterface.KeyType keyType)`
  Set a key type of the relational key which could be either Primary or Unique.

  ### Methods inherited from interface com.sas.services.information.metadata.ColumnContainerInterface

  `addColumn, addColumnAt, addColumns, getColumns, getOwningTable, removeColumn, removeColumn, removeColumns`

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### getKeyType

    RelationalKeyInterface.KeyType getKeyType() throws ServiceException, RemoteException
    Get a key type of the relational key which could be either Primary or Unique.
    Returns:
      RelationalKeyInterface.KeyType
    Throws:
      `ServiceException` - - If a repository error occurs.
      `RemoteException` - - In the event of remote object failure.

  - ### setKeyType

    void setKeyType(RelationalKeyInterface.KeyType keyType) throws ServiceException, RemoteException
    Set a key type of the relational key which could be either Primary or Unique.
    Parameters:
      `keyType` -
    Throws:
      `ServiceException` - - 1] If Primary Key exist in the Relational Table while converting the type to Primary Key. 2] If Nullable column in the unique key while converting the type to Primary Key. 3] If a repository error occurs.
      `RemoteException` - - In the event of remote object failure.

  - ### getForeignKeys

    List<ForeignKeyInterface> getForeignKeys() throws ServiceException, RemoteException
    Get associated foreign keys of the Relational Key.
    Returns:
      List
    Throws:
      `ServiceException` - - If a repository error occurs.
      `RemoteException` - - In the event of remote object failure.

  - ### getAssociatedIndex

    IndexInterface getAssociatedIndex() throws ServiceException, RemoteException
    Get the associated index with a Unique/Primary Key.
    Returns:
    Throws:
      `ServiceException` - If there's a repository error.
      `RemoteException` - in the event of remote object failure.

  - ### setAssociatedIndex

    void setAssociatedIndex(IndexInterface index) throws ServiceException, RemoteException
    Set the associated index with a Unique/Primary Key.
    Parameters:
      `index` - is the associated index with a Unique/Primary Key.
    Throws:
      `ServiceException` - If there's a repository error.
      `RemoteException` - in the event of remote object failure.